# Rescuer
[![Gem Version](https://badge.fury.io/rb/rescuer.png)](http://badge.fury.io/rb/rescuer)
[![Build Status](https://travis-ci.org/ms-ati/rescuer.png)](https://travis-ci.org/ms-ati/rescuer)
[![Dependency Status](https://gemnasium.com/ms-ati/rescuer.png)](https://gemnasium.com/ms-ati/rescuer)
[![Code Climate](https://codeclimate.com/github/ms-ati/rescuer.png)](https://codeclimate.com/github/ms-ati/rescuer)
[![Coverage Status](https://coveralls.io/repos/ms-ati/rescuer/badge.png)](https://coveralls.io/r/ms-ati/rescuer)

A functional abstraction of rescuing exceptions inspired by Scala's [Try][1] class (here's an [explanation][2]).

[1]: http://www.scala-lang.org/api/2.10.3/index.html#scala.util.Try
[2]: http://danielwestheide.com/blog/2012/12/26/the-neophytes-guide-to-scala-part-6-error-handling-with-try.html

## Usage

```ruby
denominators = [0, 1]

fractions = denominators.map { |d| Rescuer.new { 1 / d } }
#=> [#<struct Rescuer::Failure exception=#<ZeroDivisionError: divided by 0>, exceptions_to_rescue=nil>,
#    #<struct Rescuer::Success value=1, exceptions_to_rescue=nil>]
```

More coming soon...

## TODO

1.  Add any missing test to ensure exception rescuing matches all the same cases in Scala's `Try` class
1.  Come up with output for `#to_s` and `#inspect` that I like
1.  Document using yard
1.  Release 0.9.0 and solicit comments
1.  Incorporate suggested changes
1.  Release 1.0.0
1.  Potentially incorporate as a depedendency into [Rumonade](https://github.com/ms-ati/rumonade)
